--[[ 
	dragbutton.lua
		Bongos Drag Button Functions
		
	TODO
		1.11 functionality so that i can set textures properly
--]]

--constructor
function BDragButton_Create(parent)
	local button = CreateFrame("Button", parent:GetName() .. "DragButton", parent);
	button:SetPoint("BOTTOMLEFT", parent, "TOPLEFT");
	button:SetFrameStrata("DIALOG");
	button:SetToplevel(true);
	button:SetClampedToScreen(true);
	
	button:SetTextFontObject(GameFontNormal);
	button:SetHighlightFontObject(GameFontHighlight);

	local normalTexture = button:CreateTexture(parent:GetName() .. "DragButtonTexture", "ARTWORK");
	normalTexture:SetTexture(0, 0, 0, 0.5);
	normalTexture:SetPoint("TOPLEFT", button, "TOPLEFT", 4);
	normalTexture:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", 4);
	button:SetNormalTexture(normalTexture);
	
	button:SetText(parent.id);
	button:SetHeight(button:GetTextHeight()) ;
	button:SetWidth(4 + button:GetTextWidth());
	
	button:RegisterForClicks("LeftButtonDown", "LeftButtonUp", "RightButtonUp");
	BDragButton_SetScripts(button);
	
	return button;
end

function BDragButton_SetScripts(button)
	button:SetScript("OnMouseDown", BDragButton_OnMouseDown);
	button:SetScript("OnMouseUp", BDragButton_OnMouseUp);
	button:SetScript("OnShow", BDragButton_OnShow);
	button:SetScript("OnHide", BDragButton_OnHide);
end

--OnX Functions
--start moving the bar
function BDragButton_OnMouseDown()
	GameTooltip:Hide();
	this:GetParent():StartMoving();
end

--stop moving the bar
function BDragButton_OnMouseUp()
	this:GetParent():StopMovingOrSizing();
	BBar_Snap(this:GetParent());
end

--show bar shadow
function BDragButton_OnShow()
	getglobal( this:GetParent():GetName() .. "Texture" ):Show();
end

--hide bar shadow
function BDragButton_OnHide()
	getglobal( this:GetParent():GetName() .. "Texture" ):Hide();
end