-- Extra themes.
local themes = {}


SimpleCombatLog.themes = themes

themes.default = {
	theme = 'default',
	suppress = true,
	filters = {
		hit = { [1] = true, [2] = true, [8] = true, [9] = true },
		heal = { [1] = true, [2] = true, [8] = true, [9] = true },
		miss = { [1] = true, [2] = true, [8] = true, [9] = true },
		cast = { [1] = true, [2] = true, [8] = true, [9] = true },
		gain = { [1] = true, [2] = true, [8] = true, [9] = true },
		drain = { [1] = true, [2] = true, [8] = true, [9] = true },
		leech = { [1] = true, [2] = true, [8] = true, [9] = true },
		dispel = { [1] = true, [2] = true, [8] = true, [9] = true },
		buff = { [1] = true, [2] = true, [8] = true, [9] = true },
		debuff = { [1] = true, [2] = true, [8] = true, [9] = true },
		fade = { [1] = true, [2] = true, [8] = true, [9] = true },
		interrupt = { [1] = true, [2] = true, [8] = true, [9] = true },
		death = { [1] = true, [2] = true, [3] = true, [4] = true, [5] = true, [6] = true, [7] = true, [8] = true, [9] = true, [10] = true, [11] = true, [12] = true, [13] = true, [14] = true },
		environment = { [1] = true, [2] = true, [8] = true, [9] = true },
		extraattack = { [1] = true, [2] = true, [8] = true, [9] = true },
		enchant = { [1] = true, [2] = true, [8] = true, [9] = true },
	},
	events = SimpleCombatLog.events	
}

themes.damageDone = {
	theme = 'damageDone',
	suppress = true,
	resize = true,
	formats = {
		hit = "%4$s",
		hitCrit = "*%4$s*",
		hitDOT = "%4$s~",
		heal = "+%4$s",
		healCrit = "+*%4$s*",
		heal = "+%4$s~",
		miss = "%3$s",		
		environment = "|cffff0000%3$s|r",
	},
	filters = {
		hit = { [1] = true },
		heal = { [1] = true },
		miss = { [1] = true },
		environment = { [1] = true },
	},
	events = {
		['CHAT_MSG_COMBAT_SELF_HITS'] = true,
		['CHAT_MSG_COMBAT_SELF_MISSES'] = true,	
		['CHAT_MSG_SPELL_SELF_BUFF'] = true,
		['CHAT_MSG_SPELL_SELF_DAMAGE'] = true,
		['CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE'] = true,
		['CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE'] = true,
		['CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_DAMAGE'] = true,
		['CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE'] = true,		
	}
}

themes.damageTaken = {
	theme = 'damageTaken',
	suppress = true,
	resize = true,
	formats = themes.damageDone.formats, -- this need to change later.
	filters = {
		hit = { [8] = true },
		heal = { [8] = true },
		miss = { [8] = true },
		environment = { [8] = true },
	},
	events = {
		['CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS'] = true,
		['CHAT_MSG_COMBAT_CREATURE_VS_SELF_MISSES'] = true,
		['CHAT_MSG_COMBAT_HOSTILEPLAYER_HITS'] = true,
		['CHAT_MSG_COMBAT_HOSTILEPLAYER_MISSES'] = true,
		['CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE'] = true,
		['CHAT_MSG_SPELL_CREATURE_VS_SELF_BUFF'] = true,
		['CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE'] = true,
		['CHAT_MSG_SPELL_HOSTILEPLAYER_BUFF'] = true,
		['CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE'] = true,
		['CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS'] = true,
		['CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE'] = true,
		['CHAT_MSG_SPELL_DAMAGESHIELDS_ON_OTHERS'] = true,			
	}
}



SimpleCombatLog.defaultFormats = {

	-- 1st group
	hit = { "[%s] %s [%s] %s%s", { 'source', 'skill', 'victim', 'amount', 'trailers' } },
	hitCrit = { "[%s] %s Crit [%s] *%s*%s", { 'source', 'skill', 'victim', 'amount', 'trailers' } },
	hitDOT = { "[%s] %s Dot [%s] ~%s~%s", { 'source', 'skill', 'victim', 'amount', 'trailers' } },
	heal = { "[%s] %s heal [%s] %s", { 'source', 'skill', 'victim', 'amount' } },
	healCrit = { "[%s] %s crit heal [%s] *%s*", { 'source', 'skill', 'victim', 'amount' } },
	healDOT = { "[%s] %s regen [%s] ~%s~", { 'source', 'skill', 'victim', 'amount' } },
	miss = { "[%s] %s %s [%s]", { 'source', 'skill', 'missType', 'victim' } },	
	gain = { "[%s] %s : [%s] + %s %s", { 'source', 'skill', 'victim', 'amount', 'attribute' } },
	drain = { "[%s] %s : [%s] -%s %s", { 'source', 'skill', 'victim', 'amount', 'attribute' } },
	leech = { "[%s] %s : [%s] -%s %s, [%s] +%s %s", { 'source', 'skill', 'victim', 'amount', 'attribute', 'sourceGained', 'amountGained', 'attributeGained' } },

	-- 2nd group
	buff = { '[%s] |cff00ff00++|r %s', { 'victim', 'skill' } },
	debuff = { '[%s] |cffff0000++|r %s', { 'victim', 'skill' } },	
	fade = { '[%s] -- %s', { 'victim', 'skill' } },		
	dispel = { '[%s] -- %s', { 'victim', 'skill' } },
	dispelFailed = { "[%s] dispel [%s] %s failed", { 'source', 'victim', 'skill' } },			
	extraattack = { "[%s] + %s attacks (%s)", { 'victim', 'amount', 'skill' } },	
	cast = { "[%s] %s", { 'source', 'skill' } },
	castBegin = { "[%s] begins %s", { 'source', 'skill' } },
	castTargeted = { "[%s] %s [%s]", { 'source', 'skill', 'victim' } },
	interrupt = { "[%s] interrupt [%s] %s", { 'source', 'victim', 'skill' } },	
	
	-- 3rd group
	environment = { "[%s] %s %s%s", { 'victim', 'damageType', 'amount', 'trailers' } },	
	create = { "[%s] create %s", { 'source', 'item' } },
	death = { "Death: [%s]", { 'victim' } },
	deathSkill = { "Death: [%s] by %s", { 'victim', 'skill' } },
	deathSource = { "[%s] killed [%s]", { 'source', 'victim' } },
	honor = { "Honor: %s", { 'amount' } },
	honorKill = { "Killed %s %s : %s honor", { 'sourceRank', 'source', 'amount' } },
	dishonor = { "|cffff0000Dishonor: %s", { 'source' } },
	experience = { "Exp: %s", { 'amount' } },
	reputation = { "Rep: %s +%s", { 'faction',  'amount' } },
	reputationRank = { "Rep: %s with %s", { 'rank', 'faction' } },
	reputationMinus = { "Rep: %s |cffff0000-%s", { 'faction', 'amount' } },
	enchant = { "Enchant: [%s] %s to [%s] %s", { 'source', 'skill', 'victim', 'item' } },
	feedpet = { "Pet of [%s] eats %s", { 'owner', 'food' } },
	fail = { "%s fail: %s", { 'skill', 'reason' } },
	durability = { "%s %s : %s's %s damaged", { 'source', 'skill', 'victim', 'item' } },
-- 	unknown = { "|cffff0000%s|r", { 'message' } },
	
	-- Trailers
	crushing =  { "(C)", {} },
	glancing =  { "(G)", {} },
	absorb =  { "(A%s)", { 'amountAbsorbed' } },
	resist =  { "(R%s)", { 'amountResisted' } },
	block =  { "(B%s)", { 'amountBlocked' } },
	vulnerable =  { "(V%s)", { 'amountVulnerable' } }
	
}

SimpleCombatLog.defaultColors = {

	player = { r=0.5, g=0.5, b=1 },
	pet = { r=0.5, g=0.3, b=0.15 },
	raid = { r=1, g=0.5, b=0.2 },
	party = { r=0.65, g=0.65, b=1 },
	target = { r=1, g=0.5, b=1 },
	targettarget = { r=0.6, g=0.3, b=0.6 },
	other = { r=1, g=1, b=1 },
	
	physical = { r=1, g=1, b=1 },
	holy = { r=1, g=1, b=0.3 },
	fire = { r=1, g=0.15, b=0.18 },
	nature = { r=0.4, g=1, b=0.4 },
	frost = { r=0.3, g=0.3, b=0.9 },
	shadow = { r=1, g=0.7, b=1 },
	arcane = { r=0.75, g=0.75, b=0.75 },
	
	heal = { r=1, g=1, b=0.3 },
	miss = { r=1, g=0.5, b=0.5 },
	buff = { r=0.2, g=1, b=0.2 },
	debuff = { r=1, g=0.2, b=0.2 },
	skill = { r=1, g=1, b=0.4 },
}


